if defined?(::HTTP::Client) && defined?(::HTTP::Connection)
  module ::HTTP
    class Client
      request_method = respond_to?('make_request') ? 'make_request' : 'perform'
      orig_request_method = "orig_#{request_method}"
      alias_method(orig_request_method, request_method) unless method_defined?(orig_request_method)

      define_method request_method do |req, options|
        bm = Benchmark.realtime do
          @response = send(orig_request_method, req, options)
        end

        headers = @response.headers
        post_params = req.body
        post_params = Rack::Utils.parse_nested_query post_params if post_params.class == String
        
        Susu.log_all(
          req.verb, req.uri, @response.code, bm, post_params, @response.body,
          headers, headers['Content-Encoding'], headers['Content-Type']
        )

        @response
      end
    end

    class Connection
      alias_method(:orig_initialize, :initialize) unless method_defined?(:orig_initialize)

      def initialize(req, options)
        Susu.log_connection(req.uri.host, req.uri.port)
        orig_initialize(req, options)
      end
    end
  end
end
