module Net
  class HTTP
    alias_method(:orig_request, :request) unless method_defined?(:orig_request)
    alias_method(:orig_connect, :connect) unless method_defined?(:orig_connect)

    def request(req, body = nil, &block)

      url = "http://#{@address}:#{@port}#{req.path}"

      bm = Benchmark.realtime do
        @response = orig_request(req, body, &block)
      end
      headers = @response.each_header.collect
      post_params = req.body.nil? || req.body.size == 0 ? body : req.body
      post_params = Rack::Utils.parse_nested_query post_params if post_params.class == String

      if started?
        Susu.log_all(
          req.method, url, @response.code, bm, post_params,
          @response.body, headers,
          @response['Content-Encoding'], @response['Content-Type']
        )
      end

      @response
    end

    def connect
      Susu.log_connection(@address, @port) if !started?

      orig_connect
    end
  end

end
