module RestClient
  Request.instance_eval do
    class << self
      alias_method(:orig_execute, :execute) unless method_defined?(:orig_execute)

      def execute(args, &block)
        method = args[:method]
        url = args[:url]
        post_params = args[:payload]
        headers = args[:headers]
        bm = Benchmark.realtime do
          @response = orig_execute(args, &block)
        end

        Susu.log_all(
          method, url, @response.code, bm, post_params,
          @response.body, headers,
          @response['Content-Encoding'], @response['Content-Type']
        )
        @response
      end
    end
  end

end